//$$---- axlib-Projektquelltext ---- (stAXLibProjectSource)
#include <vcl.h>
#pragma hdrstop
#include <atl\atlvcl.h>

#include "clsDMXCPluginImpl.h"
#pragma package(smart_init)
TComModule  Project1Module;
TComModule &_Module = Project1Module;

// Die ATL-Objektliste enthlt ein Array aus _ATL_OBJMAP_ENTRY-Strukturen, die
// die Objekte Ihres OLE-Servers beschreiben. Diese Liste wird an das von 
// CComModule abgeleitete _Module-Objekt Ihres Projekts ber die init-Methode bergeben.
//
BEGIN_OBJECT_MAP(ObjectMap)
  OBJECT_ENTRY(CLSID_clsDMXCPlugin, TclsDMXCPluginImpl)
END_OBJECT_MAP()

// Einsprungadresse Ihres Servers, die von Windows zur Initialisierung oder
// Terminierung von Prozessen oder Threads aufgerufen wird.
//
int WINAPI DllEntryPoint(HINSTANCE hinst, unsigned long reason, void*)
{
    if (reason == DLL_PROCESS_ATTACH)
    {
        _Module.Init(ObjectMap, hinst);
        DisableThreadLibraryCalls(hinst);
    }
    return TRUE;
}

// _Module.Term wird blicherweise von DLL_PROCESS_DETACH Ihres
// DllEntryPoint verwendet. Das kann zu einer falschen Shutdown-Sequenz fhren.
// Statt einer exit-Routine soll Setup die Cleanup-Routine         
// CComModule::Term aufrufen.
//
void ModuleTerm(void)
{
    _Module.Term();
}
#pragma exit ModuleTerm 63

// Einsprungadresse Ihres Servers, die aufgerufen wird, um herauszufinden,
// ob eine DLL noch gebraucht wird oder ob sie entladen werden kann.
//
STDAPI __export DllCanUnloadNow(void)
{
    return (_Module.GetLockCount()==0) ? S_OK : S_FALSE;
}

// Einsprungadresse Ihres Servers, die es OLE erlaubt, ein Klassen-Objekt
// von Ihrem Server zu holen
//
STDAPI __export DllGetClassObject(REFCLSID rclsid, REFIID riid, LPVOID* ppv)
{
    return _Module.GetClassObject(rclsid, riid, ppv);
}

// Einsprungadresse Ihres Servers, die den Server anweist, Registrierungseintrge
// fr alle vom Modul untersttzten Klassen zu generieren
//
STDAPI __export DllRegisterServer(void)
{
    return _Module.RegisterServer(TRUE);
}

// Einsprungadresse Ihres Servers, die den Server anweist, alle Registrierungseintrge,
// die von DllRegisterServer erzeugt wurden, zu entfernen.
//
STDAPI __export DllUnregisterServer(void)
{
    return _Module.UnregisterServer();
}
//---------------------------------------------------------------------------
